# A che serve?
_nopastspam.py_ è uno script che serve a sospendere account [Mastodon](https://mastodon.help/) a zero toot, considerati spam o inattivi, e creati prima di una certa data. Lo script si basa su un [wrapper python](https://github.com/halcy/Mastodon.py) della [API di Mastodon](https://docs.joinmastodon.org/api/).

## Come si installa?
`cd [QUESTA_CARTELLA]`  
`pip3 install -r requirements.txt`

## Come si usa?
Prima di tutto bisogna cambiare i parametri dello script:  
1. `baseurl = 'https://mastodon.domain.tld'`  
2. `adminmail = 'admin@mail.tld'`  
3. `adminpz = 'passwordveramentebuona'`  
inserendo fra gli apicini dopo il segno di uguale l'indirizzo dell'istanza, la mail di un account e la password, rispettivamente per ogni linea.  
Fatto questo, lo script va lanciato con `python3` (testato per `python3.6`).
`python3 [QUESTO_SCRIPT]`
Va lanciato una prima volta per registrare lo script sul server. Le volte successive a seconda per lanciarlo effettivamente.  
Dopo il primo lancio, basta lanciarlo solo una volta per ogni volta che si vuol


## Quali versioni esistono?
Per la versione admin di test, serve un account admin e va tolto il cancelletto davanti la riga che inizia per `#user_flag`. In questo modo si ottengono tutti gli account dell'istanza e si selezionano quelli rilevanti.  
Per la versione admin operativa, serve un account admin e va tolto il cancelletto sia davanti la riga che inizia per `#user_flag`, sia davanti la riga che inizia per `#test_flag`.
La versione admin di test è consigliata rispetto alla versione utente di test perché la prima fa una sola richiesta tramite la API di Mastodon mentre la seconda ne fa troppe e [ha un limite](https://docs.joinmastodon.org/api/rate-limits/). Si consiglia di lanciare almeno una volta la versione admin di test e di testare per sé la versione admin operativa. _N.B.: la sospensione degli account non è stata testata._

## Quali account sono considerati spam o inattivi?
La versione di default seleziona tutti quegli account creati prima di luglio 2020 (data di default), con zero toot e che soddisfano uno dei due criteri seguenti:
a- account inattivi a zero toot: non hanno metadati, biografia, profilo, intestazione, e hanno un numero di follow maggiore del numero di account in autofollow (numero di default: 7);
b- account spam a zero toot: hanno un link nei metadati o nella biografia.

### Ma sono criteri discrezionali!
Certo. Come tutti i criteri.

## Ci sono delle avvertenze?
Sul caso a: non sono selezionati gli account spam a zero toot con meno seguaci del numero predefinito di autofollow.  
Sul caso b: non si fa differenza tra link fuori policy o link dentro policy. Un link a un'iniziativa antirepressione sta al livello di un casinò online. (falsi positivi)

### Come si risolve follow spambot?
Col numero di soglia per l'autofollow non è possibile selezionare gli spambot che rimuovono tutti i follow e ne mettono pochi in altre istanze. Questa è una strategia comune per finire in timeline federata. Il criterio di autofollow è inteso a tutela dee lurker. Altri criteri sono possibili, ad es. raffrontare i follow dell'account con gli autofollow attuali o tutti quelli che ci sono stati nel tempo. Se gli spambot con follow ad altre istanze vi creano particolari problemi, al momento potete cambiare direttamente il codice o forkare.

## Licenza?
0BSD.

## Garanzie?
Mai date. Usare lo script a proprio rischio e pericolo.

## Mano?
Mail qui: _mionomeutente a riseup punto net_. Più facile che legga per mail che altrove.